## uftrace 0.9.3

=== Makefile ===
VERSION := 0.9.3

# Makefiles suck: This macro sets a default value of $(2) for the
# variable named by $(1), unless the variable has been set by
# environment or command line. This is necessary for CC and AR
# because make sets default values, so the simpler ?= approach
# won't work as expected.
define allow-override
  $(if $(or $(findstring environment,$(origin $(1))),\
            $(findstring command line,$(origin $(1)))),,\
    $(eval $(1) = $(2)))
endef

# Allow setting CC and AR and LD, or setting CROSS_COMPILE as a prefix.
$(call allow-override,CC,$(CROSS_COMPILE)gcc)
$(call allow-override,AR,$(CROSS_COMPILE)ar)
$(call allow-override,LD,$(CROSS_COMPILE)ld)

uname_M := $(shell uname -m 2>/dev/null || echo not)

ARCH ?= $(shell echo $(uname_M) | sed -e s/i.86/i386/ -e s/arm.*/arm/ )
ifeq ($(ARCH),x86_64)
  ifneq ($(findstring m32,$(CFLAGS)),)
    override ARCH := i386
  endif
endif

prefix ?= /usr/local
bindir = $(prefix)/bin
libdir = $(prefix)/lib
etcdir = $(prefix)/etc
mandir = $(prefix)/share/man

srcdir = $(CURDIR)
# set objdir to $(O) by default (if any)
ifeq ($(objdir),)
    ifneq ($(O),)
        objdir = $(O)
    else
        objdir = $(CURDIR)
    endif
endif

ifneq ($(wildcard $(objdir)/.config),)
  include $(objdir)/.config
endif

RM = rm -f
INSTALL = install

export ARCH CC AR LD RM srcdir objdir LDFLAGS

COMMON_CFLAGS := -D_GNU_SOURCE $(CFLAGS) $(CPPFLAGS)
COMMON_CFLAGS += -iquote $(srcdir) -iquote $(objdir) -iquote $(srcdir)/arch/$(ARCH)
#CFLAGS-DEBUG = -g -D_GNU_SOURCE $(CFLAGS_$@)
COMMON_LDFLAGS := -lrt -ldl -pthread -Wl,-z,noexecstack $(LDFLAGS)
ifneq ($(elfdir),)
  COMMON_CFLAGS  += -I$(elfdir)/include
  COMMON_LDFLAGS += -L$(elfdir)/lib
endif

COMMON_CFLAGS += -W -Wall -Wno-unused-parameter -Wno-missing-field-initializers

#
# Note that the plain CFLAGS and LDFLAGS can be changed
# by config/Makefile later but *_*FLAGS can not.
#
UFTRACE_CFLAGS     = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_uftrace)
DEMANGLER_CFLAGS   = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_demangler)
SYMBOLS_CFLAGS     = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_symbols)
TRACEEVENT_CFLAGS  = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_traceevent)
LIB_CFLAGS         = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_lib)
LIB_CFLAGS        += -fPIC -fvisibility=hidden -fno-omit-frame-pointer
TEST_CFLAGS        = $(COMMON_CFLAGS) -DUNIT_TEST

UFTRACE_LDFLAGS    = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_uftrace)
DEMANGLER_LDFLAGS  = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_demangler)
SYMBOLS_LDFLAGS    = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_symbols)
LIB_LDFLAGS        = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_lib) -Wl,--no-undefined
TEST_LDFLAGS       = $(COMMON_LDFLAGS) -L$(objdir)/libtraceevent -ltraceevent

ifeq ($(DEBUG), 1)
  COMMON_CFLAGS += -O0 -g
else
  COMMON_CFLAGS += -O2 -g
endif

ifeq ($(TRACE), 1)
  UFTRACE_CFLAGS    += -pg -fno-omit-frame-pointer
  DEMANGLER_CFLAGS  += -pg -fno-omit-frame-pointer
  SYMBOLS_CFLAGS    += -pg -fno-omit-frame-pointer
  TRACEEVENT_CFLAGS += -pg -fno-omit-frame-pointer
  TEST_CFLAGS       += -pg -fno-omit-frame-pointer
  # cannot add -pg to LIB_CFLAGS because mcount() is not reentrant
endif

ifeq ($(COVERAGE), 1)
  COMMON_CFLAGS += -O0 -g --coverage -U_FORTIFY_SOURCE
  LIB_CFLAGS    += -O0 -g --coverage -U_FORTIFY_SOURCE
  TEST_CFLAGS   += -O0 -g --coverage -U_FORTIFY_SOURCE

  LIB_LDFLAGS   += --coverage
endif

ifeq ($(ASAN), 1)
  UFTRACE_CFLAGS    += -O0 -g -fsanitize=address -fsanitize=leak
  DEMANGLER_CFLAGS  += -O0 -g -fsanitize=address -fsanitize=leak
  SYMBOLS_CFLAGS    += -O0 -g -fsanitize=address -fsanitize=leak
  TRACEEVENT_CFLAGS += -O0 -g -fsanitize=address -fsanitize=leak
  TEST_CFLAGS       += -O0 -g -fsanitize=address -fsanitize=leak
endif

export UFTRACE_CFLAGS LIB_CFLAGS TEST_CFLAGS TEST_LDFLAGS

VERSION_GIT := $(shell git describe --tags 2> /dev/null || echo v$(VERSION))

all:

ifneq ($(wildcard $(srcdir)/check-deps/check-tstamp),)
  include $(srcdir)/check-deps/Makefile.check
endif

include $(srcdir)/Makefile.include


LIBMCOUNT_TARGETS := libmcount/libmcount.so libmcount/libmcount-fast.so
LIBMCOUNT_TARGETS += libmcount/libmcount-single.so libmcount/libmcount-fast-single.so

_TARGETS := uftrace libtraceevent/libtraceevent.a
_TARGETS += $(LIBMCOUNT_TARGETS) libmcount/libmcount-nop.so
_TARGETS += misc/demangler misc/symbols
TARGETS  := $(patsubst %,$(objdir)/%,$(_TARGETS))

UFTRACE_SRCS := $(srcdir)/uftrace.c $(wildcard $(srcdir)/cmds/*.c $(srcdir)/utils/*.c)
UFTRACE_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.o,$(UFTRACE_SRCS))

UFTRACE_OBJS_VERSION := $(objdir)/cmds/script.o $(objdir)/cmds/tui.o
UFTRACE_OBJS_VERSION += $(objdir)/cmds/dump.o $(objdir)/cmds/info.o

DEMANGLER_SRCS := $(srcdir)/misc/demangler.c $(srcdir)/utils/demangle.c
DEMANGLER_SRCS += $(srcdir)/utils/debug.c $(srcdir)/utils/utils.c
DEMANGLER_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.o,$(DEMANGLER_SRCS))

SYMBOLS_SRCS := $(srcdir)/misc/symbols.c $(srcdir)/utils/session.c
SYMBOLS_SRCS += $(srcdir)/utils/demangle.c $(srcdir)/utils/rbtree.c
SYMBOLS_SRCS += $(srcdir)/utils/utils.c $(srcdir)/utils/debug.c
SYMBOLS_SRCS += $(srcdir)/utils/filter.c $(srcdir)/utils/dwarf.c
SYMBOLS_SRCS += $(srcdir)/utils/auto-args.c $(srcdir)/utils/regs.c
SYMBOLS_SRCS += $(wildcard $(srcdir)/utils/symbol*.c)
SYMBOLS_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.o,$(SYMBOLS_SRCS))

UFTRACE_ARCH_OBJS := $(objdir)/arch/$(ARCH)/uftrace.o

UFTRACE_HDRS := $(filter-out $(srcdir)/version.h,$(wildcard $(srcdir)/*.h $(srcdir)/utils/*.h))
UFTRACE_HDRS += $(srcdir)/libmcount/mcount.h $(wildcard $(srcdir)/arch/$(ARCH)/*.h)

LIBMCOUNT_SRCS := $(filter-out %-nop.c,$(wildcard $(srcdir)/libmcount/*.c))
LIBMCOUNT_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(LIBMCOUNT_SRCS))
LIBMCOUNT_FAST_OBJS := $(patsubst $(objdir)/%.op,$(objdir)/%-fast.op,$(LIBMCOUNT_OBJS))
LIBMCOUNT_SINGLE_OBJS := $(patsubst $(objdir)/%.op,$(objdir)/%-single.op,$(LIBMCOUNT_OBJS))
LIBMCOUNT_FAST_SINGLE_OBJS := $(patsubst $(objdir)/%.op,$(objdir)/%-fast-single.op,$(LIBMCOUNT_OBJS))

LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/debug.c $(srcdir)/utils/regs.c
LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/rbtree.c $(srcdir)/utils/filter.c
LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/demangle.c $(srcdir)/utils/utils.c
LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/script.c $(srcdir)/utils/script-python.c
LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/auto-args.c $(srcdir)/utils/dwarf.c
LIBMCOUNT_UTILS_SRCS += $(wildcard $(srcdir)/utils/symbol*.c)
LIBMCOUNT_UTILS_OBJS := $(patsubst $(srcdir)/utils/%.c,$(objdir)/libmcount/%.op,$(LIBMCOUNT_UTILS_SRCS))

LIBMCOUNT_NOP_SRCS := $(srcdir)/libmcount/mcount-nop.c
LIBMCOUNT_NOP_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(LIBMCOUNT_NOP_SRCS))

LIBMCOUNT_ARCH_OBJS := $(objdir)/arch/$(ARCH)/mcount-entry.op

COMMON_DEPS := $(objdir)/.config $(UFTRACE_HDRS)
LIBMCOUNT_DEPS := $(COMMON_DEPS) $(srcdir)/libmcount/internal.h

CFLAGS_$(objdir)/mcount.op = -pthread
CFLAGS_$(objdir)/cmds/record.o = -DINSTALL_LIB_PATH='"$(libdir)"'
CFLAGS_$(objdir)/cmds/live.o = -DINSTALL_LIB_PATH='"$(libdir)"'
LDFLAGS_$(objdir)/uftrace = -L$(objdir)/libtraceevent -ltraceevent -ldl

LIBMCOUNT_FAST_CFLAGS := -DDISABLE_MCOUNT_FILTER
LIBMCOUNT_SINGLE_CFLAGS := -DSINGLE_THREAD
LIBMCOUNT_FAST_SINGLE_CFLAGS := -DDISABLE_MCOUNT_FILTER -DSINGLE_THREAD

CFLAGS_$(objdir)/utils/demangle.o  = -Wno-unused-value
CFLAGS_$(objdir)/utils/demangle.op = -Wno-unused-value

MAKEFLAGS += --no-print-directory


all: $(objdir)/.config $(TARGETS)

$(objdir)/.config: $(srcdir)/configure $(srcdir)/check-deps/Makefile
	$(QUIET_GEN)$(srcdir)/configure -p -o $@ $(MAKEOVERRIDES)
	@$(MAKE) -C $(objdir)
# The above recursive make will handle all build procedure with
# updated dependency.  So just abort the current build.
	$(error)

config: $(srcdir)/configure
	$(QUIET_GEN)$(srcdir)/configure -o $(objdir)/.config $(MAKEOVERRIDES)

$(LIBMCOUNT_UTILS_OBJS): $(objdir)/libmcount/%.op: $(srcdir)/utils/%.c $(LIBMCOUNT_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(objdir)/libmcount/mcount.op: $(objdir)/version.h 

$(LIBMCOUNT_OBJS): $(objdir)/%.op: $(srcdir)/%.c $(LIBMCOUNT_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(LIBMCOUNT_FAST_OBJS): $(objdir)/%-fast.op: $(srcdir)/%.c $(LIBMCOUNT_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) $(LIBMCOUNT_FAST_CFLAGS) -c -o $@ $<

$(LIBMCOUNT_SINGLE_OBJS): $(objdir)/%-single.op: $(srcdir)/%.c $(LIBMCOUNT_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) $(LIBMCOUNT_SINGLE_CFLAGS) -c -o $@ $<

$(LIBMCOUNT_FAST_SINGLE_OBJS): $(objdir)/%-fast-single.op: $(srcdir)/%.c $(LIBMCOUNT_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) $(LIBMCOUNT_FAST_SINGLE_CFLAGS) -c -o $@ $<

$(LIBMCOUNT_NOP_OBJS): $(objdir)/%.op: $(srcdir)/%.c $(LIBMCOUNT_DEPS)
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(objdir)/libmcount/libmcount.so: $(LIBMCOUNT_OBJS) $(LIBMCOUNT_UTILS_OBJS) $(LIBMCOUNT_ARCH_OBJS)
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libmcount/libmcount-fast.so: $(LIBMCOUNT_FAST_OBJS) $(LIBMCOUNT_UTILS_OBJS) $(LIBMCOUNT_ARCH_OBJS)
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libmcount/libmcount-single.so: $(LIBMCOUNT_SINGLE_OBJS) $(LIBMCOUNT_UTILS_OBJS) $(LIBMCOUNT_ARCH_OBJS)
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libmcount/libmcount-fast-single.so: $(LIBMCOUNT_FAST_SINGLE_OBJS) $(LIBMCOUNT_UTILS_OBJS) $(LIBMCOUNT_ARCH_OBJS)
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(objdir)/libmcount/libmcount-nop.so: $(LIBMCOUNT_NOP_OBJS)
	$(QUIET_LINK)$(CC) -shared -o $@ $^ $(LIB_LDFLAGS)

$(LIBMCOUNT_ARCH_OBJS): $(wildcard $(srcdir)/arch/$(ARCH)/*.[cS]) $(LIBMCOUNT_DEPS)
	@$(MAKE) -B -C $(srcdir)/arch/$(ARCH) $@

$(UFTRACE_ARCH_OBJS): $(wildcard $(srcdir)/arch/$(ARCH)/*.[cS]) $(COMMON_DEPS)
	@$(MAKE) -B -C $(srcdir)/arch/$(ARCH) $@

$(objdir)/libtraceevent/libtraceevent.a: $(wildcard $(srcdir)/libtraceevent/*.[ch]) $(objdir)/.config
	@$(MAKE) -C $(srcdir)/libtraceevent BUILD_SRC=$(srcdir)/libtraceevent BUILD_OUTPUT=$(objdir)/libtraceevent CONFIG_FLAGS="$(TRACEEVENT_CFLAGS)"

$(objdir)/uftrace.o: $(srcdir)/uftrace.c $(objdir)/version.h $(COMMON_DEPS)
	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<

$(objdir)/misc/demangler.o: $(srcdir)/misc/demangler.c $(objdir)/version.h $(COMMON_DEPS)
	$(QUIET_CC)$(CC) $(DEMANGLER_CFLAGS) -c -o $@ $<

$(objdir)/misc/symbols.o: $(srcdir)/misc/symbols.c $(objdir)/version.h $(COMMON_DEPS)
	$(QUIET_CC)$(CC) $(SYMBOLS_CFLAGS) -c -o $@ $<

$(UFTRACE_OBJS_VERSION): $(objdir)/version.h

$(filter-out $(objdir)/uftrace.o, $(UFTRACE_OBJS)): $(objdir)/%.o: $(srcdir)/%.c $(COMMON_DEPS)
	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<

$(objdir)/version.h: PHONY
	@$(srcdir)/misc/version.sh $@ $(VERSION_GIT) $(srcdir)

$(srcdir)/utils/auto-args.h: $(srcdir)/misc/prototypes.h $(srcdir)/misc/gen-autoargs.py
	$(QUIET_GEN)$(srcdir)/misc/gen-autoargs.py -i $< -o $@

$(objdir)/uftrace: $(UFTRACE_OBJS) $(UFTRACE_ARCH_OBJS) $(objdir)/libtraceevent/libtraceevent.a
	$(QUIET_LINK)$(CC) $(UFTRACE_CFLAGS) -o $@ $(UFTRACE_OBJS) $(UFTRACE_ARCH_OBJS) $(UFTRACE_LDFLAGS)

$(objdir)/misc/demangler: $(DEMANGLER_OBJS)
	$(QUIET_LINK)$(CC) $(DEMANGLER_CFLAGS) -o $@ $(DEMANGLER_OBJS) $(DEMANGLER_LDFLAGS)

$(objdir)/misc/symbols: $(SYMBOLS_OBJS)
	$(QUIET_LINK)$(CC) $(SYMBOLS_CFLAGS) -o $@ $(SYMBOLS_OBJS) $(SYMBOLS_LDFLAGS)

install: all
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(bindir)
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(libdir)
	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(etcdir)/bash_completion.d
ifneq ($(wildcard $(elfdir)/lib/libelf.so),)
ifeq ($(wildcard $(prefix)/lib/libelf.so),)
	# install libelf only when it's not in the install directory.
	$(call QUIET_INSTALL, libelf)
	$(Q)$(INSTALL) $(elfdir)/lib/libelf.so   $(DESTDIR)$(libdir)/libelf.so
endif
endif
	$(call QUIET_INSTALL, uftrace)
	$(Q)$(INSTALL) $(objdir)/uftrace         $(DESTDIR)$(bindir)/uftrace
	$(call QUIET_INSTALL, libmcount)
	$(Q)$(INSTALL) $(objdir)/libmcount/libmcount.so   $(DESTDIR)$(libdir)/libmcount.so

=== check-deps/Makefile ===
CHECK_LIST := clock_without_librt
CHECK_LIST += cc_has_mfentry
CHECK_LIST += cxa_demangle
CHECK_LIST += have_libelf
CHECK_LIST += cc_has_mno_sse2
CHECK_LIST += have_libpython2.7
CHECK_LIST += perf_clockid
CHECK_LIST += perf_context_switch
CHECK_LIST += arm_has_hardfp
CHECK_LIST += have_libncurses
CHECK_LIST += have_libdw
CHECK_LIST += have_libcapstone

#
# This is needed for checking build dependency
#

CHECK_CFLAGS  = $(CFLAGS)  $(CFLAGS_$@) -Werror
CHECK_LDFLAGS = $(LDFLAGS) $(LDFLAGS_$@)

CFLAGS_cc_has_mfentry = -mfentry
LDFLAGS_cxa_demangle = -lstdc++
LDFLAGS_have_libelf = -lelf
CFLAGS_cc_has_mno_sse2 = -mno-sse2
LDFLAGS_have_libpython2.7 = -lpython2.7
CFLAGS_have_libncurses  = $(shell pkg-config --cflags ncursesw 2> /dev/null)
LDFLAGS_have_libncurses = $(shell pkg-config --libs   ncursesw 2> /dev/null)
CFLAGS_have_libdw  = $(shell pkg-config --cflags libdw 2> /dev/null)
LDFLAGS_have_libdw = $(shell pkg-config --libs   libdw 2> /dev/null || echo "-ldw")
CFLAGS_have_libcapstone  = $(shell pkg-config --cflags capstone 2> /dev/null)
LDFLAGS_have_libcapstone = $(shell pkg-config --libs   capstone 2> /dev/null)

check-build: check-tstamp $(CHECK_LIST)

$(CHECK_LIST): %: __%.c
	@$(CC) $(CHECK_CFLAGS) -o $@ $< $(CHECK_LDFLAGS) > /dev/null 2>&1

check-tstamp: PHONY
	@touch $@
	@if [ `id -u` -eq 0 ]; then chmod 666 $@; fi

check-clean:
	@$(RM) $(shell find -type f -executable) check-tstamp *.o

.PHONY: PHONY;

=== libtraceevent/Makefile ===
# trace-cmd version
EP_VERSION = 1
EP_PATCHLEVEL = 1
EP_EXTRAVERSION = 0

# file format version
FILE_VERSION = 6

MAKEFLAGS += --no-print-directory


# Makefiles suck: This macro sets a default value of $(2) for the
# variable named by $(1), unless the variable has been set by
# environment or command line. This is necessary for CC and AR
# because make sets default values, so the simpler ?= approach
# won't work as expected.
define allow-override
  $(if $(or $(findstring environment,$(origin $(1))),\
            $(findstring command line,$(origin $(1)))),,\
    $(eval $(1) = $(2)))
endef

# Allow setting CC and AR, or setting CROSS_COMPILE as a prefix.
$(call allow-override,CC,$(CROSS_COMPILE)gcc)
$(call allow-override,AR,$(CROSS_COMPILE)ar)

EXT = -std=gnu99
INSTALL = install

# Use DESTDIR for installing into a different root directory.
# This is useful for building a package. The program will be
# installed in this directory as if it was the root directory.
# Then the build tool can move it later.
DESTDIR ?=
DESTDIR_SQ = '$(subst ','\'',$(DESTDIR))'

prefix ?= /usr/local
bindir_relative = bin
bindir = $(prefix)/$(bindir_relative)
man_dir = $(prefix)/share/man
man_dir_SQ = '$(subst ','\'',$(man_dir))'

export man_dir man_dir_SQ INSTALL
export DESTDIR DESTDIR_SQ

include $(if $(BUILD_SRC),$(BUILD_SRC)/)../Makefile.include

# copy a bit from Linux kbuild

ifeq ("$(origin V)", "command line")
  VERBOSE = $(V)
endif
ifndef VERBOSE
  VERBOSE = 0
endif

ifeq ("$(origin O)", "command line")
  BUILD_OUTPUT := $(O)
endif

ifeq ($(BUILD_SRC),)
ifneq ($(BUILD_OUTPUT),)

define build_output
  $(if $(VERBOSE:1=),@)+$(MAKE) -C $(BUILD_OUTPUT) \
  BUILD_SRC=$(CURDIR)/ -f $(CURDIR)/Makefile $1
endef

all: sub-make

$(MAKECMDGOALS): sub-make

sub-make: force
	$(call build_output, $(MAKECMDGOALS))


# Leave processing to above invocation of make
skip-makefile := 1

endif # BUILD_OUTPUT
endif # BUILD_SRC

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

srctree		:= $(if $(BUILD_SRC),$(BUILD_SRC),$(CURDIR))
objtree		:= $(if $(BUILD_OUTPUT),$(BUILD_OUTPUT),$(CURDIR))
src		:= $(srctree)
obj		:= $(objtree)

export prefix bindir src obj

# Shell quotes
bindir_SQ = $(subst ','\'',$(bindir))
bindir_relative_SQ = $(subst ','\'',$(bindir_relative))

LIB_FILE = $(obj)/libtraceevent.a # $(obj)/libtraceevent.so

CONFIG_INCLUDES = 
CONFIG_LIBS	=
CONFIG_FLAGS	=

VERSION		= $(EP_VERSION)
PATCHLEVEL	= $(EP_PATCHLEVEL)
EXTRAVERSION	= $(EP_EXTRAVERSION)

OBJ		= $@
N		=

export Q VERBOSE

EVENT_PARSE_VERSION = $(EP_VERSION).$(EP_PATCHLEVEL).$(EP_EXTRAVERSION)

INCLUDES = -I $(srctree)/include $(CONFIG_INCLUDES)

# Set compile option CFLAGS if not set elsewhere
CFLAGS ?= -g -Wall

# Append required CFLAGS
override CFLAGS += $(CONFIG_FLAGS) $(INCLUDES)
override CFLAGS += $(udis86-flags) -D_GNU_SOURCE

ifeq ($(VERBOSE),1)
  Q =
else
  Q = @
endif

do_compile_shared_library =			\
	($(print_shared_lib_compile)		\
	$(CC) --shared $^ -o $@)

do_build_static_lib =				\
	($(print_static_lib_build)		\
	$(RM) $@;  $(AR) rcs $@ $^)


do_compile = $(QUIET_CC)$(CC) -c $(CFLAGS) $(EXT) $< -o $@;

$(obj)/%.o: $(src)/%.c
	$(call do_compile)

PEVENT_LIB_OBJS  = $(obj)/event-parse.o
PEVENT_LIB_OBJS += $(obj)/event-plugin.o
PEVENT_LIB_OBJS += $(obj)/trace-seq.o
PEVENT_LIB_OBJS += $(obj)/parse-filter.o
PEVENT_LIB_OBJS += $(obj)/parse-utils.o
PEVENT_LIB_OBJS += $(obj)/kbuffer-parse.o

ALL_OBJS = $(PEVENT_LIB_OBJS) $(PLUGIN_OBJS)

CMD_TARGETS = $(LIB_FILE) $(PLUGINS)

TARGETS = $(CMD_TARGETS)


all: all_cmd

all_cmd: $(CMD_TARGETS)

$(obj)/libtraceevent.so: $(PEVENT_LIB_OBJS)
	$(QUIET_LINK)$(CC) --shared $^ -o $@

$(obj)/libtraceevent.a: $(PEVENT_LIB_OBJS)
	$(QUIET_LINK)$(RM) $@; $(AR) rcs $@ $^

$(PEVENT_LIB_OBJS): $(obj)/%.o: $(src)/%.c $(obj)/TRACEEVENT-CFLAGS
	$(QUIET_CC_FPIC)$(CC) -c $(CFLAGS) $(EXT) $< -o $@

define make_version.h
  (echo '/* This file is automatically generated. Do not modify. */';		\
   echo \#define VERSION_CODE $(shell						\
   expr $(VERSION) \* 256 + $(PATCHLEVEL));					\
   echo '#define EXTRAVERSION ' $(EXTRAVERSION);				\
   echo '#define VERSION_STRING "'$(VERSION).$(PATCHLEVEL).$(EXTRAVERSION)'"';	\
   echo '#define FILE_VERSION '$(FILE_VERSION);					\
  ) > $1
endef

define update_version.h
  ($(call make_version.h, $@.tmp);		\
    if [ -r $@ ] && cmp -s $@ $@.tmp; then	\
      rm -f $@.tmp;				\
    else					\
      echo '  UPDATE                 $@';	\
      mv -f $@.tmp $@;				\
    fi);
endef

ep_version.h: force
	$(Q)$(N)$(call update_version.h)

VERSION_FILES = ep_version.h

define update_dir
  (echo $1 > $@.tmp;				\
   if [ -r $@ ] && cmp -s $@ $@.tmp; then	\
     rm -f $@.tmp;				\
   else						\
     echo '  UPDATE                 $@';	\
     mv -f $@.tmp $@;				\
   fi);
endef

## make deps

all_objs := $(sort $(ALL_OBJS))
all_deps := $(all_objs:$(obj)/%.o=$(obj)/.%.d)

# let .d file also depends on the source and header files
define check_deps
  @set -e; $(RM) $@; \
  $(CC) -MM $(CFLAGS) $< > $@.$$$$; \
  sed 's,\($*\)\.o[ :]*,\1.o $@ : ,g' < $@.$$$$ > $@; \
  $(RM) $@.$$$$
endef

$(all_deps): $(obj)/.%.d: $(src)/%.c
	$(Q)$(call check_deps)

$(all_objs) : $(obj)/%.o : $(obj)/.%.d

dep_includes := $(wildcard $(all_deps))

ifneq ($(dep_includes),)
 include $(dep_includes)
endif

### Detect environment changes
TRACK_CFLAGS = $(subst ','\'',$(CFLAGS)):$(ARCH):$(CROSS_COMPILE)

$(obj)/TRACEEVENT-CFLAGS: force
	@FLAGS='$(TRACK_CFLAGS)'; \
	    if test x"$$FLAGS" != x"`cat $(obj)/TRACEEVENT-CFLAGS 2>/dev/null`" ; then \
		echo 1>&2 "  FLAGS:   * new build flags or cross compiler"; \
		echo "$$FLAGS" > $(obj)/TRACEEVENT-CFLAGS; \
            fi

tags:	force
	$(RM) tags
	find . -name '*.[ch]' | xargs ctags --extra=+f --c-kinds=+px \
	--regex-c++='/_PE\(([^,)]*).*/PEVENT_ERRNO__\1/'

TAGS:	force
	$(RM) TAGS
	find . -name '*.[ch]' | xargs etags \
	--regex='/_PE(\([^,)]*\).*/PEVENT_ERRNO__\1/'

define do_install
	if [ ! -d '$(DESTDIR_SQ)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR_SQ)$2';	\
	fi;						\
	$(INSTALL) $1 '$(DESTDIR_SQ)$2'
endef

install_lib: all_cmd
	$(call QUIET_INSTALL, $(LIB_FILE)) \
		$(call do_install,$(LIB_FILE),$(bindir_SQ))

install: install_lib

clean:
	$(call QUIET_CLEAN, libtraceevent) \
		$(RM) $(obj)/*.o $(obj)/*~ $(TARGETS) $(obj)/*.a $(obj)/*.so \
		$(VERSION_FILES) $(obj)/.*.d $(RM) $(obj)/TRACEEVENT-CFLAGS tags TAGS

endif # skip-makefile

PHONY += force
force:

# Declare the contents of the .PHONY variable as phony.  We keep that
# information in a variable so we can use it in if_changed and friends.
.PHONY: $(PHONY)

=== tests/Makefile ===
TEST_CFLAGS  += -include $(srcdir)/tests/unittest.h -Wno-sign-compare
TEST_CFLAGS  += -pg -g

UNIT_TEST_SRC := $(srcdir)/uftrace.c
UNIT_TEST_SRC += $(wildcard $(srcdir)/cmds/*.c)
UNIT_TEST_SRC += $(wildcard $(srcdir)/utils/*.c)
UNIT_TEST_SRC += $(wildcard $(srcdir)/arch/$(ARCH)/*.c)
UNIT_TEST_SRC += $(wildcard $(srcdir)/libmcount/*.c)
UNIT_TEST_OBJ := $(patsubst $(srcdir)/%.c,$(objdir)/%.ot,$(UNIT_TEST_SRC))
UNIT_TEST_OBJ := $(filter-out %-nop.ot,$(UNIT_TEST_OBJ))

UNIT_TEST_OBJ_VERSION := $(objdir)/cmds/script.ot $(objdir)/cmds/tui.ot
UNIT_TEST_OBJ_VERSION += $(objdir)/cmds/dump.ot   $(objdir)/cmds/info.ot
UNIT_TEST_OBJ_VERSION += $(objdir)/libmcount/mcount.ot

FULL_WORKER := -j $(shell getconf _NPROCESSORS_ONLN || echo 1)

# these needs to be recursively expanded
JOPT = $(filter -j%, $(MAKEFLAGS))
WORKER = $(if $(JOPT), $(if $(patsubst -j%,%,$(JOPT)), $(JOPT), $(FULL_WORKER)), -j1)

include $(srcdir)/Makefile.include

test: test_all

test_all: unittest
	$(QUIET_TEST)./unittest $(TESTARG)
	$(QUIET_TEST)./runtest.py $(WORKER) $(TESTARG)

test_run:
	$(QUIET_TEST)./runtest.py $(WORKER) $(TESTARG)

test_unit: unittest
	$(QUIET_TEST)./unittest $(TESTARG)

unittest: unittest.c unittest.h $(UNIT_TEST_OBJ)
	$(QUIET_LINK)$(CC) -o $@ $(TEST_CFLAGS) $< $(UNIT_TEST_OBJ) $(TEST_LDFLAGS)

$(UNIT_TEST_OBJ_VERSION): $(objdir)/version.h

$(UNIT_TEST_OBJ): $(objdir)/%.ot: $(srcdir)/%.c $(objdir)/.config $(srcdir)/tests/unittest.h
	$(QUIET_CC)$(CC) -o $@ -c $(TEST_CFLAGS) $<

clean:
	$(call QUIET_CLEAN, test)
	@rm -f *.o *.so *.pyc t-* unittest $(UNIT_TEST_OBJ)

.PHONY: clean test test_run test_unit

=== arch/arm/Makefile ===
sdir := $(srcdir)/arch/arm
odir := $(objdir)/arch/arm

LINKFLAGS := -r

include $(srcdir)/Makefile.include

ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)
ARCH_MCOUNT_SRC = $(wildcard $(sdir)/mcount-*.c)
ARCH_UFTRACE_SRC = $(sdir)/cpuinfo.c

ARCH_MCOUNT_OBJS  = $(patsubst $(sdir)/%.S,$(odir)/%.op,$(ARCH_ENTRY_SRC))
ARCH_MCOUNT_OBJS += $(patsubst $(sdir)/%.c,$(odir)/%.op,$(ARCH_MCOUNT_SRC))
ARCH_UFTRACE_OBJS = $(patsubst $(sdir)/%.c,$(odir)/%.o,$(ARCH_UFTRACE_SRC))

all: $(odir)/entry.op

$(odir)/mcount-entry.op: $(ARCH_MCOUNT_OBJS)
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/uftrace.o: $(ARCH_UFTRACE_OBJS)
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/%.op: $(sdir)/%.S
	$(QUIET_ASM)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(odir)/%.op: $(sdir)/%.c
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(odir)/%.o: $(sdir)/%.c
	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<

clean:
	$(RM) $(odir)/*.op $(odir)/*.o

=== debian/changelog ===
uftrace (0.9.3-1ubuntu1) focal; urgency=medium

  * Build using python2.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 01 Apr 2020 13:39:56 +0200

uftrace (0.9.3-1) unstable; urgency=low

  * New upstream release
  * Adds support for nodoc build option
  * Adds i386 as a build target
  * Make build reproducible (this mostly involved adding the
    -ffile-prefix-map compiler option)
  * Adds support for autopkgtest
  * Add Rules-Requires-Root: no
  * Bump Standards-Version to 4.4.0
  * Install private shared objects to /usr/lib/$(DEB_HOST_MULTIARCH)/uftrace

 -- paul cannon <pik@debian.org>  Wed, 18 Sep 2019 21:14:16 -0500

uftrace (0.9.0-1) unstable; urgency=medium

  * New upstream release:
    + Fixes FTBFS on buster/sid (closes: #906512).
    + Now reports correct version (closes: #886863).
  * Adds arm64 as a build target (closes: #898000, and thank you, Matthias
    Klose).
  * Add new (optional) build dependencies for the sake of features:
    pkg-config, libpython2.7-dev, libdw-dev, libncursesw5-dev
  * Bump Standards-Version to 4.2.1.

 -- paul cannon <pik@debian.org>  Tue, 11 Sep 2018 16:19:19 -0500

=== debian/control ===
Source: uftrace
Section: utils
Priority: optional
Maintainer: paul cannon <pik@debian.org>
Build-Depends: debhelper (>= 9), libelf-dev, pandoc, python2, pkg-config,
 libpython2.7-dev, libdw-dev, libncursesw5-dev, libcapstone-dev,
 bash-completion
Standards-Version: 4.4.0
Homepage: https://github.com/namhyung/uftrace
Rules-Requires-Root: no
Vcs-Git: https://github.com/thepaul/uftrace -b deb
Vcs-Browser: https://github.com/thepaul/uftrace/tree/deb

Package: uftrace
Architecture: amd64 arm64 armhf i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Traces and analyzes execution of programs written in C/C++
 The uftrace tool is intended for tracing and analyzing the execution of
 programs written in C or C++. It was heavily inspired by the ftrace framework
 of the Linux kernel (especially the function graph tracer) and supports
 userspace programs. It supports various kinds of commands and filters to help
 analysis of the program's execution and performance.
 .
 It traces each function in the executable and shows time durations. It can
 also trace external library calls - but usually only entry and exit are
 supported. It is also possible to trace other (nested) external library calls
 and/or internal function calls in the library call.
 .
 It can show detailed execution flow at function level, and report which
 function has the highest overhead. It also shows various information
 related to the execution environment.
 .
 You can setup filters to exclude or include specific functions when tracing.
 In addition, function arguments and return values can be saved and shown
 later.
 .
 The uftrace tool supports multi-process and/or multi-threaded applications.
 It can also trace kernel functions as well, with root privileges and if the
 system enables the function graph tracer in the kernel
 (CONFIG_FUNCTION_GRAPH_TRACER=y).

=== debian/rules ===
#!/usr/bin/make -f

# build with PIE explicitly where appropriate
export CFLAGS_uftrace=-fPIE
export CFLAGS_traceevent=-fPIE
export LDFLAGS_uftrace=-pie

# don't put current build paths in executables
export CFLAGS_configure=-ffile-prefix-map=$(CURDIR)=.

LIBDIR := /usr/lib/$(DEB_HOST_MULTIARCH)/uftrace

%:
	dh $@

ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
# suppress man page generation
export has_pandoc=no
endif

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
# verbose build output
export V=1
endif

override_dh_auto_configure:
	LDFLAGS=-Wl,-z,now,-z,relro CFLAGS=$(CFLAGS_configure) ./configure --prefix=/usr --libdir=$(LIBDIR)

override_dh_auto_install:
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp/

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	$(MAKE) -j1 test
endif

override_dh_auto_clean:
	dh_auto_clean
	$(RM) .config
	$(MAKE) -C check-deps check-clean

=== debian/tests/control ===
Test-Command: cd tests && objdir=/usr/bin python2 runtest.py
Depends: @, build-essential, python2
Restrictions: allow-stderr

## uftrace 0.9.4

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION := 0.9.3
+VERSION := 0.9.4
 
 # Makefiles suck: This macro sets a default value of $(2) for the
 # variable named by $(1), unless the variable has been set by
@@ -19,8 +19,8 @@
 uname_M := $(shell uname -m 2>/dev/null || echo not)
 
 ARCH ?= $(shell echo $(uname_M) | sed -e s/i.86/i386/ -e s/arm.*/arm/ )
-ifeq ($(ARCH),x86_64)
-  ifneq ($(findstring m32,$(CFLAGS)),)
+ifneq ($(findstring x86,$(ARCH)),)
+  ifneq ($(findstring m32,$(CC) $(CFLAGS)),)
     override ARCH := i386
   endif
 endif
@@ -30,6 +30,11 @@
 libdir = $(prefix)/lib
 etcdir = $(prefix)/etc
 mandir = $(prefix)/share/man
+docdir = $(srcdir)/doc
+
+ifeq ($(DOCLANG), ko)
+  docdir = $(srcdir)/doc/ko
+endif
 
 srcdir = $(CURDIR)
 # set objdir to $(O) by default (if any)
@@ -86,28 +91,44 @@
 endif
 
 ifeq ($(TRACE), 1)
-  UFTRACE_CFLAGS    += -pg -fno-omit-frame-pointer
-  DEMANGLER_CFLAGS  += -pg -fno-omit-frame-pointer
-  SYMBOLS_CFLAGS    += -pg -fno-omit-frame-pointer
-  TRACEEVENT_CFLAGS += -pg -fno-omit-frame-pointer
-  TEST_CFLAGS       += -pg -fno-omit-frame-pointer
+  TRACE_CFLAGS      := -pg -fno-omit-frame-pointer
+  UFTRACE_CFLAGS    += $(TRACE_CFLAGS)
+  DEMANGLER_CFLAGS  += $(TRACE_CFLAGS)
+  SYMBOLS_CFLAGS    += $(TRACE_CFLAGS)
+  TRACEEVENT_CFLAGS += $(TRACE_CFLAGS)
+  TEST_CFLAGS       += $(TRACE_CFLAGS)
   # cannot add -pg to LIB_CFLAGS because mcount() is not reentrant
 endif
 
 ifeq ($(COVERAGE), 1)
-  COMMON_CFLAGS += -O0 -g --coverage -U_FORTIFY_SOURCE
-  LIB_CFLAGS    += -O0 -g --coverage -U_FORTIFY_SOURCE
-  TEST_CFLAGS   += -O0 -g --coverage -U_FORTIFY_SOURCE
+  COVERAGE_CFLAGS := -O0 -g --coverage -U_FORTIFY_SOURCE
+  COMMON_CFLAGS   += $(COVERAGE_CFLAGS)
+  LIB_CFLAGS      += $(COVERAGE_CFLAGS)
+  TEST_CFLAGS     += $(COVERAGE_CFLAGS)
 
   LIB_LDFLAGS   += --coverage
 endif
 
 ifeq ($(ASAN), 1)
-  UFTRACE_CFLAGS    += -O0 -g -fsanitize=address -fsanitize=leak
-  DEMANGLER_CFLAGS  += -O0 -g -fsanitize=address -fsanitize=leak
-  SYMBOLS_CFLAGS    += -O0 -g -fsanitize=address -fsanitize=leak
-  TRACEEVENT_CFLAGS += -O0 -g -fsanitize=address -fsanitize=leak
-  TEST_CFLAGS       += -O0 -g -fsanitize=address -fsanitize=leak
+  ASAN_CFLAGS       := -O0 -g -fsanitize=address,leak
+  UFTRACE_CFLAGS    += $(ASAN_CFLAGS)
+  DEMANGLER_CFLAGS  += $(ASAN_CFLAGS)
+  SYMBOLS_CFLAGS    += $(ASAN_CFLAGS)
+  TRACEEVENT_CFLAGS += $(ASAN_CFLAGS)
+  TEST_CFLAGS       += $(ASAN_CFLAGS)
+endif
+
+ifneq ($(SAN),)
+  ifeq ($(SAN), all)
+    SAN_CFLAGS := -O0 -g -fsanitize=address,leak,undefined
+  else
+    SAN_CFLAGS := -O0 -g -fsanitize=$(SAN)
+  endif
+  UFTRACE_CFLAGS    += $(SAN_CFLAGS)
+  DEMANGLER_CFLAGS  += $(SAN_CFLAGS)
+  SYMBOLS_CFLAGS    += $(SAN_CFLAGS)
+  TRACEEVENT_CFLAGS += $(SAN_CFLAGS)
+  TEST_CFLAGS       += $(SAN_CFLAGS)
 endif
 
 export UFTRACE_CFLAGS LIB_CFLAGS TEST_CFLAGS TEST_LDFLAGS
@@ -163,7 +184,7 @@
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/debug.c $(srcdir)/utils/regs.c
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/rbtree.c $(srcdir)/utils/filter.c
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/demangle.c $(srcdir)/utils/utils.c
-LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/script.c $(srcdir)/utils/script-python.c
+LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/script.c $(srcdir)/utils/script-python.c $(srcdir)/utils/script-luajit.c
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/auto-args.c $(srcdir)/utils/dwarf.c
 LIBMCOUNT_UTILS_SRCS += $(wildcard $(srcdir)/utils/symbol*.c)
 LIBMCOUNT_UTILS_OBJS := $(patsubst $(srcdir)/utils/%.c,$(objdir)/libmcount/%.op,$(LIBMCOUNT_UTILS_SRCS))
@@ -282,12 +303,3 @@
 	$(Q)$(INSTALL) -d -m 755 $(DESTDIR)$(etcdir)/bash_completion.d
 ifneq ($(wildcard $(elfdir)/lib/libelf.so),)
 ifeq ($(wildcard $(prefix)/lib/libelf.so),)
-	# install libelf only when it's not in the install directory.
-	$(call QUIET_INSTALL, libelf)
-	$(Q)$(INSTALL) $(elfdir)/lib/libelf.so   $(DESTDIR)$(libdir)/libelf.so
-endif
-endif
-	$(call QUIET_INSTALL, uftrace)
-	$(Q)$(INSTALL) $(objdir)/uftrace         $(DESTDIR)$(bindir)/uftrace
-	$(call QUIET_INSTALL, libmcount)
-	$(Q)$(INSTALL) $(objdir)/libmcount/libmcount.so   $(DESTDIR)$(libdir)/libmcount.so

=== check-deps/Makefile ===
--- 
+++ 
@@ -4,6 +4,8 @@
 CHECK_LIST += have_libelf
 CHECK_LIST += cc_has_mno_sse2
 CHECK_LIST += have_libpython2.7
+CHECK_LIST += have_libpython3
+CHECK_LIST += have_libluajit
 CHECK_LIST += perf_clockid
 CHECK_LIST += perf_context_switch
 CHECK_LIST += arm_has_hardfp
@@ -23,6 +25,10 @@
 LDFLAGS_have_libelf = -lelf
 CFLAGS_cc_has_mno_sse2 = -mno-sse2
 LDFLAGS_have_libpython2.7 = -lpython2.7
+CFLAGS_have_libpython3 = $(shell python3-config --cflags 2> /dev/null)
+LDFLAGS_have_libpython3 = $(shell python3-config --libs 2> /dev/null)
+CFLAGS_have_libluajit = $(shell pkg-config --cflags luajit 2> /dev/null)
+LDFLAGS_have_libluajit = $(shell pkg-config --libs  luajit 2> /dev/null)
 CFLAGS_have_libncurses  = $(shell pkg-config --cflags ncursesw 2> /dev/null)
 LDFLAGS_have_libncurses = $(shell pkg-config --libs   ncursesw 2> /dev/null)
 CFLAGS_have_libdw  = $(shell pkg-config --cflags libdw 2> /dev/null)

=== arch/aarch64/Makefile ===
sdir := $(srcdir)/arch/aarch64
odir := $(objdir)/arch/aarch64

LINKFLAGS := -r

include $(srcdir)/Makefile.include

ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)
ARCH_MCOUNT_SRC = $(wildcard $(sdir)/mcount-*.c)
ARCH_UFTRACE_SRC = $(sdir)/cpuinfo.c

ARCH_MCOUNT_OBJS  = $(patsubst $(sdir)/%.S,$(odir)/%.op,$(ARCH_ENTRY_SRC))
ARCH_MCOUNT_OBJS += $(patsubst $(sdir)/%.c,$(odir)/%.op,$(ARCH_MCOUNT_SRC))
ARCH_UFTRACE_OBJS = $(patsubst $(sdir)/%.c,$(odir)/%.o,$(ARCH_UFTRACE_SRC))

all: $(odir)/entry.op

$(odir)/mcount-entry.op: $(ARCH_MCOUNT_OBJS)
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/uftrace.o: $(ARCH_UFTRACE_OBJS)
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/%.op: $(sdir)/%.S
	$(QUIET_ASM)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(odir)/%.op: $(sdir)/%.c
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(odir)/%.o: $(sdir)/%.c
	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<

clean:
	$(RM) $(odir)/*.op $(odir)/*.o

=== arch/i386/Makefile ===
LINKFLAGS := -r -m elf_i386

sdir := $(srcdir)/arch/i386
odir := $(objdir)/arch/i386

include $(srcdir)/Makefile.include

ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)
ARCH_MCOUNT_SRC = $(wildcard $(sdir)/mcount-*.c)
ARCH_UFTRACE_SRC = $(sdir)/cpuinfo.c

ARCH_MCOUNT_OBJS  = $(patsubst $(sdir)/%.S,$(odir)/%.op,$(ARCH_ENTRY_SRC))
ARCH_MCOUNT_OBJS += $(patsubst $(sdir)/%.c,$(odir)/%.op,$(ARCH_MCOUNT_SRC))
ARCH_UFTRACE_OBJS = $(patsubst $(sdir)/%.c,$(odir)/%.o,$(ARCH_UFTRACE_SRC))

all: $(odir)/entry.op

$(odir)/mcount-entry.op: $(ARCH_MCOUNT_OBJS)
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/uftrace.o: $(ARCH_UFTRACE_OBJS)
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/%.op: $(sdir)/%.S
	$(QUIET_ASM)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(odir)/%.op: $(sdir)/%.c
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(odir)/%.o: $(sdir)/%.c
	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<

clean:
	$(RM) $(odir)/*.op $(odir)/*.o

=== arch/x86_64/Makefile ===
LINKFLAGS := -r

sdir := $(srcdir)/arch/x86_64
odir := $(objdir)/arch/x86_64

include $(srcdir)/Makefile.include

ARCH_ENTRY_SRC = $(wildcard $(sdir)/*.S)
ARCH_MCOUNT_SRC = $(wildcard $(sdir)/mcount-*.c) $(sdir)/symbol.c
ARCH_UFTRACE_SRC = $(sdir)/cpuinfo.c $(sdir)/symbol.c

ARCH_MCOUNT_OBJS  = $(patsubst $(sdir)/%.S,$(odir)/%.op,$(ARCH_ENTRY_SRC))
ARCH_MCOUNT_OBJS += $(patsubst $(sdir)/%.c,$(odir)/%.op,$(ARCH_MCOUNT_SRC))
ARCH_UFTRACE_OBJS = $(patsubst $(sdir)/%.c,$(odir)/%.o,$(ARCH_UFTRACE_SRC))

all: $(odir)/entry.op

$(odir)/mcount-entry.op: $(ARCH_MCOUNT_OBJS)
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/uftrace.o: $(ARCH_UFTRACE_OBJS)
	$(QUIET_LINK)$(LD) $(LINKFLAGS) -o $@ $^

$(odir)/%.op: $(sdir)/%.S
	$(QUIET_ASM)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(odir)/%.op: $(sdir)/%.c
	$(QUIET_CC_FPIC)$(CC) $(LIB_CFLAGS) -c -o $@ $<

$(odir)/%.o: $(sdir)/%.c
	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<

clean:
	$(RM) $(odir)/*.op $(odir)/*.o

=== tests/arch/arm/Makefile ===
CC = gcc
RM = rm -f
UFTRACE = ../../../uftrace -L ../../.. --flat

#CFLAGS = -g -finstrument-functions
CFLAGS = -g -pg -fno-omit-frame-pointer

TARGETS = t-thumb t-arm-thumb

all: $(TARGETS)

TARGETS_O1 = $(patsubst %,%_O1,$(TARGETS))
TARGETS_O2 = $(patsubst %,%_O2,$(TARGETS))
TARGETS_O3 = $(patsubst %,%_O3,$(TARGETS))
TARGETS_Os = $(patsubst %,%_Os,$(TARGETS))

ALL_TARGETS = $(TARGETS) $(TARGETS_O1) $(TARGETS_O2) $(TARGETS_O3) $(TARGETS_Os)

test_run = $(UFTRACE) $(1) 1 2 3 | sort -k2 | cut -d/ -f2 | cut -d, -f1 | sed -e 's/<[0-9a-f]\+>/<unknown>/'
test_and_diff = printf "%20s: " $(1); $(test_run) | diff -U0 $(2) - > $(1)-diff && \
		printf [${GREEN}OK${RESET}]"\n" || printf [${RED}NG${RESET}]"\n"

all: $(ALL_TARGETS)

t-thumb: thumb.c
	$(CC) $(CFLAGS) -mthumb -o $@ $<

t-thumb_%: thumb.c
	$(CC) $(CFLAGS) -$(@:t-thumb_%=%) -mthumb -o $@ $<

t-arm-thumb: a.c t.c
	$(CC) $(CFLAGS) -marm -c a.c
	$(CC) $(CFLAGS) -mthumb -c t.c
	$(CC) $(CFLAGS) -o $@ a.o t.o

t-arm-thumb_%: a.c t.c
	$(CC) $(CFLAGS) -$(@:t-arm-thumb_%=%) -marm -c a.c
	$(CC) $(CFLAGS) -$(@:t-arm-thumb_%=%) -mthumb -c t.c
	$(CC) $(CFLAGS) -$(@:t-arm-thumb_%=%) -o $@ a.o t.o

test: all
	@echo testing -O0
	@for t in $(TARGETS); do $(call test_run, $${t}) > $${t}_result; done
	@echo testing -O1
	@for t in $(TARGETS_O1); do $(call test_and_diff, $${t}, $${t%_O1}_result); done
	@echo testing -O2
	@for t in $(TARGETS_O2); do $(call test_and_diff, $${t}, $${t%_O2}_result); done
	@echo testing -O3
	@for t in $(TARGETS_O3); do $(call test_and_diff, $${t}, $${t%_O3}_result); done
	@echo testing -Os
	@for t in $(TARGETS_Os); do $(call test_and_diff, $${t}, $${t%_Os}_result); done

clean:
	$(RM) $(ALL_TARGETS) *.o uftrace.data* gmon.out *-diff

.PHONY: clean test arch

=== tests/arch/x86_64/Makefile ===
CC = gcc
RM = rm -f
UFTRACE = ../../../uftrace -L ../../.. --flat

CFLAGS = -g -finstrument-functions

TARGETS =

ifdef HAVE_CC_MFENTRY
TARGETS += t-fentry
endif

TARGETS_O1 = $(patsubst %,%_O1,$(TARGETS))
TARGETS_O2 = $(patsubst %,%_O2,$(TARGETS))
TARGETS_O3 = $(patsubst %,%_O3,$(TARGETS))
TARGETS_Os = $(patsubst %,%_Os,$(TARGETS))

ALL_TARGETS = $(TARGETS) $(TARGETS_O1) $(TARGETS_O2) $(TARGETS_O3) $(TARGETS_Os)

test_run = $(UFTRACE) $(1) 1 2 3 | sort -k2 | cut -d/ -f2 | cut -d, -f1 | sed -e 's/<[0-9a-f]\+>/<unknown>/'
test_and_diff = printf "%20s: " $(1); $(test_run) | diff -U0 $(2) - > $(1)-diff && \
		printf [${GREEN}OK${RESET}]"\n" || printf [${RED}NG${RESET}]"\n"

all: $(ALL_TARGETS)

t-fentry: fentry.c
	$(CC) $(CFLAGS) -mfentry -o $@ $<

t-fentry_%: fentry.c
	$(CC) $(CFLAGS) -$(@:t-fentry_%=%) -mfentry -o $@ $<

test: all
	@echo testing -O0
	@for t in $(TARGETS); do $(call test_run, $${t}) > $${t}_result; done
	@echo testing -O1
	@for t in $(TARGETS_O1); do $(call test_and_diff, $${t}, $${t%_O1}_result); done
	@echo testing -O2
	@for t in $(TARGETS_O2); do $(call test_and_diff, $${t}, $${t%_O2}_result); done
	@echo testing -O3
	@for t in $(TARGETS_O3); do $(call test_and_diff, $${t}, $${t%_O3}_result); done
	@echo testing -Os
	@for t in $(TARGETS_Os); do $(call test_and_diff, $${t}, $${t%_Os}_result); done

clean:
	$(RM) $(ALL_TARGETS) *.o uftrace.data* gmon.out *-diff

.PHONY: clean test arch

=== debian/changelog ===
uftrace (0.9.4-0.2ubuntu1) hirsute; urgency=medium

  * d/p/0001-test-Robustify-mcount_wrap_dlopen-test.patch: Import patch from
    upstream Git to fix a failing test.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 02 Jan 2021 18:47:36 -0500

uftrace (0.9.4-0.2) unstable; urgency=high

  * Non-maintainer upload.
  * Remove the autopkgtest for now, it doesn't fail when tests fail
    but fails for other reasons on arm64. (Closes: #947089)

 -- Adrian Bunk <bunk@debian.org>  Wed, 22 Apr 2020 17:06:49 +0300

uftrace (0.9.4-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    - Fixes FTBFS on armhf. (Closes: #947089)

 -- Adrian Bunk <bunk@debian.org>  Mon, 13 Apr 2020 16:18:27 +0300

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: uftrace
 Section: utils
 Priority: optional
-Maintainer: paul cannon <pik@debian.org>
-Build-Depends: debhelper (>= 9), libelf-dev, pandoc, python2, pkg-config,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: paul cannon <pik@debian.org>
+Build-Depends: debhelper (>= 9), libelf-dev, pandoc, python, pkg-config,
  libpython2.7-dev, libdw-dev, libncursesw5-dev, libcapstone-dev,
  bash-completion
 Standards-Version: 4.4.0

## uftrace 0.12

=== debian/changelog ===
uftrace (0.12-5) unstable; urgency=medium

  * Upload to sid.

 -- Gürkan Myczko <tar@debian.org>  Thu, 06 Oct 2022 08:44:04 +0200

uftrace (0.12-4) experimental; urgency=medium

  * Disable tests as they all fail.

 -- Gürkan Myczko <tar@debian.org>  Thu, 06 Oct 2022 07:29:18 +0200

uftrace (0.12-3) experimental; urgency=medium

  * d/clean: fixed.
  * Fix tests. (Closes: #1015032)
  * Bump standards version to 4.6.1.
  * d/changelog: change the 0.10-1 entry from UNRELEASED to unstable.

 -- Gürkan Myczko <tar@debian.org>  Wed, 05 Oct 2022 15:01:02 +0200

uftrace (0.12-2) unstable; urgency=medium

  * Reactivate python patch.

 -- Gürkan Myczko <tar@debian.org>  Thu, 21 Jul 2022 14:53:04 +0200

uftrace (0.12-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Sun, 19 Jun 2022 21:24:15 +0200

uftrace (0.11-6) unstable; urgency=medium

  * Source only upload.

 -- Gürkan Myczko <tar@debian.org>  Tue, 07 Jun 2022 11:00:10 +0200

uftrace (0.11-5) unstable; urgency=low

  * Remove armhf as a build target again; still not building

 -- paul cannon <pik@debian.org>  Thu, 31 Mar 2022 20:58:38 -0500

uftrace (0.11-4) unstable; urgency=medium

  * Switch back to the original Git history (Gürkan Myczko mistakenly thought
    there was not one already, and started a new history. This revision
    includes the relevant changes from that history.)
  * Remove build-depends on python-is-python3 (dependencies on that package
    are disallowed by Debian's Python policy.)
  * Reinstate spelling and python3 shebang patches
  * use debhelper-compat instead of debian/compat
  * Fix build on experimental armhf (thanks to Nobuhiro Iwamatsu;
    closes: #1008134)
  * Uploading the 0.11 series to unstable (closes: #1007959)

 -- paul cannon <pik@debian.org>  Tue, 22 Mar 2022 11:35:12 -0500

uftrace (0.11-3) experimental; urgency=medium

  * Try to disable failing tests temporarily.

 -- Gürkan Myczko <tar@debian.org>  Tue, 15 Mar 2022 15:00:01 +0100

uftrace (0.11-2) experimental; urgency=medium

  * d/control: add build-depends for python-is-python3.

 -- Gürkan Myczko <tar@debian.org>  Tue, 15 Mar 2022 12:02:31 +0100

uftrace (0.11-1) experimental; urgency=medium

  * Add myself to Uploaders.
  * Team upload.
  * New upstream version. (Closes: #966988, #967228, #938745)
  * Bump standards version to 4.6.0.
  * Bump debhelper version to 12, drop d/compat.
  * d/clean: added.

 -- Gürkan Myczko <tar@debian.org>  Thu, 25 Nov 2021 11:14:00 +0100

uftrace (0.10-1) unstable; urgency=medium

  * New upstream release, which includes:
    - No longer requires python2 (closes: #967228, #938745)
    - Fixes FTBFS from spurious test failures (closes: 966988). Thanks
      to Logan Rosen for identifying the issue and submitting a patch,
      although I failed to address it in the 0.9.4 series.
  * Many thanks to Adrian Bunk for the NMUs releasing 0.9.4 and fixing the
    build failures.

 -- paul cannon <pik@debian.org>  Mon, 06 Sep 2021 15:54:23 -0500
